/*
 *  Copyright (C) 2005, 2006 Mikhail A. Kryshen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  $Id: Function.java,v 1.5 2006/12/14 14:39:22 mikhail Exp $
 */

package kryshen.tema;

import java.io.*;
import java.util.*;
import java.sql.ResultSet;

/**
 * Abstact class for TEMA functions.
 *
 * @author Mikhail A. Kryshen
 */
public abstract class Function {

    /**
     * Invoke the function.
     *
     * @param fdp FunctionDataParser to access function arguments.
     * @param out Writer for the function output.
     */
    public abstract int invoke(FunctionDataParser fdp, Writer out)
        throws IOException, TemplateException;
}
