/*
 *  Copyright (C) 2005, 2006 Mikhail A. Kryshen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  $Id: Functions.java,v 1.11 2006/12/14 19:44:31 mikhail Exp $
 */

package kryshen.tema;

import java.io.*;
import java.util.*;

import kryshen.tema.functions.*;

/**
 * Standard TEMA functions.
 *
 * @author Mikhail A. Kryshen
 */
public class Functions {
    // TODO: arithmetics, conditions

    /**
     * Register all standard functions.
     *
     * @param p TemplateParser to register functions in.
     */
    static void registerAllFunctions(TemplateParser p) {
        p.registerFunction("!",          Standard.NULL_OUTPUT);
        p.registerFunction("set",        Standard.SET);
        p.registerFunction("load",       Standard.LOAD);
        p.registerFunction("query",      Standard.QUERY);
        p.registerFunction("prepare",    Standard.PREPARE);
        p.registerFunction("replace",    Standard.REPLACE);
        p.registerFunction("xml_escape", Standard.XML_ESCAPE);
        p.registerFunction("xml_cdata",  Standard.XML_CDATA);

        p.registerFunction("define",     Define.DEFINE);

        p.registerFunction("write",      IO.WRITE);
        p.registerFunction("read",       IO.READ);
        p.registerFunction("include",    IO.INCLUDE);
        p.registerFunction("copy",       IO.COPY);

	p.registerFunction("false",      Logics.FALSE);
	p.registerFunction("true",       Logics.TRUE);
        p.registerFunction("optional",   Logics.OPTIONAL);

        p.registerFunction("image",      ImageConverter.IMAGE);

	/* 
	   Other functuons:
	   db - defined in Tema.query().
	   nextarg, data - defined in Define.invoke().
	*/
    }
}
