/*
 *  Copyright (C) 2006 Mikhail A. Kryshen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  $Id: TemplateException.java,v 1.5 2006/12/14 14:39:22 mikhail Exp $
 */

package kryshen.tema;

/**
 * Signals that template parsing fails.
 *
 * @author Mikhail A. Kryshen
 */
public class TemplateException extends Exception {
    //private String source;
    //private int line;

//     public TemplateException(String message) {
// 	super(message);
//     }

//     public TemplateException(String message, Throwable cause) {
// 	super(message, cause);
//     }

    public TemplateException(String message, Throwable cause,
                             TemplateReader tr) {
        this(message, cause, tr.getSource(), tr.getLineNumber() + 1);
    }

    public TemplateException(String message, TemplateReader tr) {
        this(message, tr.getSource(), tr.getLineNumber() + 1);
    }

    public TemplateException(String message, Throwable cause,
                             String source, int line) {
        super(source + ":" + line + ": " + message, cause);
        //this.source = source;
        //this.line = line;
    }
    
    public TemplateException(String message, String source, int line) {
        super(source + ":" + line + ": " + message);
        //this.source = source;
        //this.line = line;
    }
}
